package Jama;
import Jama.util.*;

public class EigenvalueDecomposition implements uka.patch.Patchable, uka.transport.Transportable, java.io.Serializable {
   public void createPatch(Object _copy, uka.patch.PatchOutput po) throws java.io.IOException {
      EigenvalueDecomposition copy = (EigenvalueDecomposition)_copy;
      if (po.writeDiff(this.issymmetric, copy.issymmetric)) copy.issymmetric = this.issymmetric;
      if (po.writeDiff(this.n, copy.n)) copy.n = this.n;
      copy.ort = this.ort = (double[])po.writeDiff(this.ort, copy.ort);
      copy.H = this.H = (double[][])po.writeDiff(this.H, copy.H);
      copy.V = this.V = (double[][])po.writeDiff(this.V, copy.V);
      copy.e = this.e = (double[])po.writeDiff(this.e, copy.e);
      copy.d = this.d = (double[])po.writeDiff(this.d, copy.d);
   }
   public void applyPatch(Object _copy, uka.patch.PatchInput pi) throws java.io.IOException, ClassNotFoundException {
      EigenvalueDecomposition copy = (EigenvalueDecomposition)_copy;
      if (pi.hasDiff()) copy.issymmetric = this.issymmetric = pi.getDiffAsBoolean();
      if (pi.hasDiff()) copy.n = this.n = pi.getDiffAsInt();
      if (pi.hasDiff()) copy.ort = this.ort = (double[])pi.getDiffAsObject();
      if (pi.hasDiff()) copy.H = this.H = (double[][])pi.getDiffAsObject();
      if (pi.hasDiff()) copy.V = this.V = (double[][])pi.getDiffAsObject();
      if (pi.hasDiff()) copy.e = this.e = (double[])pi.getDiffAsObject();
      if (pi.hasDiff()) copy.d = this.d = (double[])pi.getDiffAsObject();
   }
   public void descendReferences(uka.patch.ReferenceConsumer c) throws java.io.IOException {
      c.descend(this.ort);
      c.descend(this.H);
      c.descend(this.V);
      c.descend(this.e);
      c.descend(this.d);
   }
   public void filterReferences(uka.patch.ReferenceFilter f) {
      this.ort = (double[])f.filter(this.ort);
      this.H = (double[][])f.filter(this.H);
      this.V = (double[][])f.filter(this.V);
      this.e = (double[])f.filter(this.e);
      this.d = (double[])f.filter(this.d);
   }
   public Object clone() {
      try {
         return super.clone();
      }  catch (CloneNotSupportedException ex) {
         throw new AssertionError("Declared Cloneable but clone() is still unsupported");
      }
   }
   public static final uka.transport.TransportDescriptor TRANSPORT_DESCRIPTOR = new uka.transport.TransportDescriptor(){
      public Object unmarshalReference(uka.transport.UnmarshalStream s, int id) throws java.io.IOException, ClassNotFoundException {
         return new EigenvalueDecomposition(s, id);
      }
      public boolean unmarshal(Object obj, uka.transport.UnmarshalStream s) throws ClassNotFoundException, java.io.IOException {
         ((EigenvalueDecomposition)obj).unmarshal(s);
         return false;
      }
      public void marshalReference(Object obj, uka.transport.MarshalStream s) throws java.io.IOException {
         ((EigenvalueDecomposition)obj).marshalReference(s);
      }
      public void marshal(Object obj, uka.transport.MarshalStream s) throws java.io.IOException {
         ((EigenvalueDecomposition)obj).marshal(s);
      }
      public Object deepClone(Object orig, int id, uka.transport.DeepClone _helper) throws CloneNotSupportedException {
         try {
            return new EigenvalueDecomposition((EigenvalueDecomposition)orig, id, _helper);
         }  catch (java.io.IOException ex) {
            throw (CloneNotSupportedException)new CloneNotSupportedException().initCause(ex);
         }
      }
      public boolean deepCloneReferences(Object orig, Object copy, uka.transport.DeepClone _helper) throws CloneNotSupportedException {
         ((EigenvalueDecomposition)copy).deepCloneReferences((EigenvalueDecomposition)orig, _helper);
         return false;
      }
      public Class getType() {
         return EigenvalueDecomposition.class;
      }
   };
   public uka.transport.TransportDescriptor getTransportDescriptor() {
      return TRANSPORT_DESCRIPTOR;
   }
   private static final int _SIZE = uka.transport.BasicIO.SIZEOF_boolean + uka.transport.BasicIO.SIZEOF_int;
   public EigenvalueDecomposition(uka.transport.UnmarshalStream _stream, int _id) throws java.io.IOException, ClassNotFoundException {
      _stream.register(this, _id);
   }
   public void unmarshal(uka.transport.UnmarshalStream _stream) throws java.io.IOException, ClassNotFoundException {
      _stream.request(EigenvalueDecomposition._SIZE);
      byte[] _buffer = _stream.getBuffer();
      int _pos = _stream.getPosition();
      this.issymmetric = uka.transport.BasicIO.extractBoolean(_buffer, _pos);
      _pos += uka.transport.BasicIO.SIZEOF_boolean;
      this.n = uka.transport.BasicIO.extractInt(_buffer, _pos);
      _pos += uka.transport.BasicIO.SIZEOF_int;
      _stream.accept(EigenvalueDecomposition._SIZE);
      this.ort = (double[])_stream.readReference();
      this.H = (double[][])_stream.readReference();
      this.V = (double[][])_stream.readReference();
      this.e = (double[])_stream.readReference();
      this.d = (double[])_stream.readReference();
   }
   public void marshalReference(uka.transport.MarshalStream _stream) throws java.io.IOException {
   }
   public void marshal(uka.transport.MarshalStream _stream) throws java.io.IOException {
      _stream.reserve(EigenvalueDecomposition._SIZE);
      byte[] _buffer = _stream.getBuffer();
      int _pos = _stream.getPosition();
      _pos = uka.transport.BasicIO.insert(_buffer, _pos, this.issymmetric);
      _pos = uka.transport.BasicIO.insert(_buffer, _pos, this.n);
      _stream.deliver(_SIZE);
      _stream.writeReference(this.ort);
      _stream.writeReference(this.H);
      _stream.writeReference(this.V);
      _stream.writeReference(this.e);
      _stream.writeReference(this.d);
   }
   public EigenvalueDecomposition(EigenvalueDecomposition _orig, int _id, uka.transport.DeepClone _helper) throws CloneNotSupportedException, java.io.IOException {
      _helper.add(_id, this);
      this.issymmetric = _orig.issymmetric;
      this.n = _orig.n;
   }
   public void deepCloneReferences(EigenvalueDecomposition _orig, uka.transport.DeepClone _helper) throws CloneNotSupportedException {
      this.ort = (double[])_helper.internalDeepClone(_orig.ort);
      this.H = (double[][])_helper.internalDeepClone(_orig.H);
      this.V = (double[][])_helper.internalDeepClone(_orig.V);
      this.e = (double[])_helper.internalDeepClone(_orig.e);
      this.d = (double[])_helper.internalDeepClone(_orig.d);
   }
   private int n;
   private boolean issymmetric;
   private double[] d;
   private double[] e;
   private double[][] V;
   private double[][] H;
   private double[] ort;
   private transient double cdivr;
   private transient double cdivi;
   public EigenvalueDecomposition(Matrix Arg) {
      super();
      double[][] A = Arg.getArray();
      Jama.EigenvalueDecomposition.this.n = Arg.getColumnDimension();
      Jama.EigenvalueDecomposition.this.V = new double[Jama.EigenvalueDecomposition.this.n][Jama.EigenvalueDecomposition.this.n];
      Jama.EigenvalueDecomposition.this.d = new double[Jama.EigenvalueDecomposition.this.n];
      Jama.EigenvalueDecomposition.this.e = new double[Jama.EigenvalueDecomposition.this.n];
      Jama.EigenvalueDecomposition.this.issymmetric = true;
      for (int j = 0; j < Jama.EigenvalueDecomposition.this.n & Jama.EigenvalueDecomposition.this.issymmetric; j++) {
         for (int i = 0; i < Jama.EigenvalueDecomposition.this.n & Jama.EigenvalueDecomposition.this.issymmetric; i++) {
            Jama.EigenvalueDecomposition.this.issymmetric = A[i][j] == A[j][i];
         }
      }
      if (Jama.EigenvalueDecomposition.this.issymmetric) {
         for (int i = 0; i < Jama.EigenvalueDecomposition.this.n; i++) {
            for (int j = 0; j < Jama.EigenvalueDecomposition.this.n; j++) {
               Jama.EigenvalueDecomposition.this.V[i][j] = A[i][j];
            }
         }
         tred2();
         tql2();
      } else {
         Jama.EigenvalueDecomposition.this.H = new double[Jama.EigenvalueDecomposition.this.n][Jama.EigenvalueDecomposition.this.n];
         Jama.EigenvalueDecomposition.this.ort = new double[Jama.EigenvalueDecomposition.this.n];
         for (int j = 0; j < Jama.EigenvalueDecomposition.this.n; j++) {
            for (int i = 0; i < Jama.EigenvalueDecomposition.this.n; i++) {
               Jama.EigenvalueDecomposition.this.H[i][j] = A[i][j];
            }
         }
         orthes();
         hqr2();
      }
   }
   private void cdiv(double xr, double xi, double yr, double yi) {
      double r;
      double d;
      if (Math.abs(yr) > Math.abs(yi)) {
         r = yi / yr;
         d = yr + r * yi;
         Jama.EigenvalueDecomposition.this.cdivr = (xr + r * xi) / d;
         Jama.EigenvalueDecomposition.this.cdivi = (xi - r * xr) / d;
      } else {
         r = yr / yi;
         d = yi + r * yr;
         Jama.EigenvalueDecomposition.this.cdivr = (r * xr + xi) / d;
         Jama.EigenvalueDecomposition.this.cdivi = (r * xi - xr) / d;
      }
   }
   public Matrix getD() {
      Matrix X = new Matrix(Jama.EigenvalueDecomposition.this.n, Jama.EigenvalueDecomposition.this.n);
      double[][] D = X.getArray();
      for (int i = 0; i < Jama.EigenvalueDecomposition.this.n; i++) {
         for (int j = 0; j < Jama.EigenvalueDecomposition.this.n; j++) {
            D[i][j] = 0.0;
         }
         D[i][i] = Jama.EigenvalueDecomposition.this.d[i];
         if (Jama.EigenvalueDecomposition.this.e[i] > 0) {
            D[i][i + 1] = Jama.EigenvalueDecomposition.this.e[i];
         } else if (Jama.EigenvalueDecomposition.this.e[i] < 0) {
            D[i][i - 1] = Jama.EigenvalueDecomposition.this.e[i];
         }
      }
      return X;
   }
   public double[] getImagEigenvalues() {
      return Jama.EigenvalueDecomposition.this.e;
   }
   public double[] getRealEigenvalues() {
      return Jama.EigenvalueDecomposition.this.d;
   }
   public Matrix getV() {
      return new Matrix(Jama.EigenvalueDecomposition.this.V, Jama.EigenvalueDecomposition.this.n, Jama.EigenvalueDecomposition.this.n);
   }
   private void hqr2() {
      int nn = this.n;
      int n = nn - 1;
      int low = 0;
      int high = nn - 1;
      double eps = Math.pow(2.0, -52.0);
      double exshift = 0.0;
      double p = 0;
      double q = 0;
      double r = 0;
      double s = 0;
      double z = 0;
      double t;
      double w;
      double x;
      double y;
      double norm = 0.0;
      for (int i = 0; i < nn; i++) {
         if (i < low | i > high) {
            Jama.EigenvalueDecomposition.this.d[i] = Jama.EigenvalueDecomposition.this.H[i][i];
            Jama.EigenvalueDecomposition.this.e[i] = 0.0;
         }
         for (int j = Math.max(i - 1, 0); j < nn; j++) {
            norm = norm + Math.abs(Jama.EigenvalueDecomposition.this.H[i][j]);
         }
      }
      int iter = 0;
      while (n >= low) {
         int l = n;
         while (l > low) {
            s = Math.abs(Jama.EigenvalueDecomposition.this.H[l - 1][l - 1]) + Math.abs(Jama.EigenvalueDecomposition.this.H[l][l]);
            if (s == 0.0) {
               s = norm;
            }
            if (Math.abs(Jama.EigenvalueDecomposition.this.H[l][l - 1]) < eps * s) {
               break;
            }
            l--;
         }
         if (l == n) {
            Jama.EigenvalueDecomposition.this.H[n][n] = Jama.EigenvalueDecomposition.this.H[n][n] + exshift;
            Jama.EigenvalueDecomposition.this.d[n] = Jama.EigenvalueDecomposition.this.H[n][n];
            Jama.EigenvalueDecomposition.this.e[n] = 0.0;
            n--;
            iter = 0;
         } else if (l == n - 1) {
            w = Jama.EigenvalueDecomposition.this.H[n][n - 1] * Jama.EigenvalueDecomposition.this.H[n - 1][n];
            p = (Jama.EigenvalueDecomposition.this.H[n - 1][n - 1] - Jama.EigenvalueDecomposition.this.H[n][n]) / 2.0;
            q = p * p + w;
            z = Math.sqrt(Math.abs(q));
            Jama.EigenvalueDecomposition.this.H[n][n] = Jama.EigenvalueDecomposition.this.H[n][n] + exshift;
            Jama.EigenvalueDecomposition.this.H[n - 1][n - 1] = Jama.EigenvalueDecomposition.this.H[n - 1][n - 1] + exshift;
            x = Jama.EigenvalueDecomposition.this.H[n][n];
            if (q >= 0) {
               if (p >= 0) {
                  z = p + z;
               } else {
                  z = p - z;
               }
               Jama.EigenvalueDecomposition.this.d[n - 1] = x + z;
               Jama.EigenvalueDecomposition.this.d[n] = Jama.EigenvalueDecomposition.this.d[n - 1];
               if (z != 0.0) {
                  Jama.EigenvalueDecomposition.this.d[n] = x - w / z;
               }
               Jama.EigenvalueDecomposition.this.e[n - 1] = 0.0;
               Jama.EigenvalueDecomposition.this.e[n] = 0.0;
               x = Jama.EigenvalueDecomposition.this.H[n][n - 1];
               s = Math.abs(x) + Math.abs(z);
               p = x / s;
               q = z / s;
               r = Math.sqrt(p * p + q * q);
               p = p / r;
               q = q / r;
               for (int j = n - 1; j < nn; j++) {
                  z = Jama.EigenvalueDecomposition.this.H[n - 1][j];
                  Jama.EigenvalueDecomposition.this.H[n - 1][j] = q * z + p * Jama.EigenvalueDecomposition.this.H[n][j];
                  Jama.EigenvalueDecomposition.this.H[n][j] = q * Jama.EigenvalueDecomposition.this.H[n][j] - p * z;
               }
               for (int i = 0; i <= n; i++) {
                  z = Jama.EigenvalueDecomposition.this.H[i][n - 1];
                  Jama.EigenvalueDecomposition.this.H[i][n - 1] = q * z + p * Jama.EigenvalueDecomposition.this.H[i][n];
                  Jama.EigenvalueDecomposition.this.H[i][n] = q * Jama.EigenvalueDecomposition.this.H[i][n] - p * z;
               }
               for (int i = low; i <= high; i++) {
                  z = Jama.EigenvalueDecomposition.this.V[i][n - 1];
                  Jama.EigenvalueDecomposition.this.V[i][n - 1] = q * z + p * Jama.EigenvalueDecomposition.this.V[i][n];
                  Jama.EigenvalueDecomposition.this.V[i][n] = q * Jama.EigenvalueDecomposition.this.V[i][n] - p * z;
               }
            } else {
               Jama.EigenvalueDecomposition.this.d[n - 1] = x + p;
               Jama.EigenvalueDecomposition.this.d[n] = x + p;
               Jama.EigenvalueDecomposition.this.e[n - 1] = z;
               Jama.EigenvalueDecomposition.this.e[n] = -z;
            }
            n = n - 2;
            iter = 0;
         } else {
            x = Jama.EigenvalueDecomposition.this.H[n][n];
            y = 0.0;
            w = 0.0;
            if (l < n) {
               y = Jama.EigenvalueDecomposition.this.H[n - 1][n - 1];
               w = Jama.EigenvalueDecomposition.this.H[n][n - 1] * Jama.EigenvalueDecomposition.this.H[n - 1][n];
            }
            if (iter == 10) {
               exshift += x;
               for (int i = low; i <= n; i++) {
                  Jama.EigenvalueDecomposition.this.H[i][i] -= x;
               }
               s = Math.abs(Jama.EigenvalueDecomposition.this.H[n][n - 1]) + Math.abs(Jama.EigenvalueDecomposition.this.H[n - 1][n - 2]);
               x = y = 0.75 * s;
               w = -0.4375 * s * s;
            }
            if (iter == 30) {
               s = (y - x) / 2.0;
               s = s * s + w;
               if (s > 0) {
                  s = Math.sqrt(s);
                  if (y < x) {
                     s = -s;
                  }
                  s = x - w / ((y - x) / 2.0 + s);
                  for (int i = low; i <= n; i++) {
                     Jama.EigenvalueDecomposition.this.H[i][i] -= s;
                  }
                  exshift += s;
                  x = y = w = 0.964;
               }
            }
            iter = iter + 1;
            int m = n - 2;
            while (m >= l) {
               z = Jama.EigenvalueDecomposition.this.H[m][m];
               r = x - z;
               s = y - z;
               p = (r * s - w) / Jama.EigenvalueDecomposition.this.H[m + 1][m] + Jama.EigenvalueDecomposition.this.H[m][m + 1];
               q = Jama.EigenvalueDecomposition.this.H[m + 1][m + 1] - z - r - s;
               r = Jama.EigenvalueDecomposition.this.H[m + 2][m + 1];
               s = Math.abs(p) + Math.abs(q) + Math.abs(r);
               p = p / s;
               q = q / s;
               r = r / s;
               if (m == l) {
                  break;
               }
               if (Math.abs(Jama.EigenvalueDecomposition.this.H[m][m - 1]) * (Math.abs(q) + Math.abs(r)) < eps * (Math.abs(p) * (Math.abs(Jama.EigenvalueDecomposition.this.H[m - 1][m - 1]) + Math.abs(z) + Math.abs(Jama.EigenvalueDecomposition.this.H[m + 1][m + 1])))) {
                  break;
               }
               m--;
            }
            for (int i = m + 2; i <= n; i++) {
               Jama.EigenvalueDecomposition.this.H[i][i - 2] = 0.0;
               if (i > m + 2) {
                  Jama.EigenvalueDecomposition.this.H[i][i - 3] = 0.0;
               }
            }
            for (int k = m; k <= n - 1; k++) {
               boolean notlast = k != n - 1;
               if (k != m) {
                  p = Jama.EigenvalueDecomposition.this.H[k][k - 1];
                  q = Jama.EigenvalueDecomposition.this.H[k + 1][k - 1];
                  r = notlast ? Jama.EigenvalueDecomposition.this.H[k + 2][k - 1] : 0.0;
                  x = Math.abs(p) + Math.abs(q) + Math.abs(r);
                  if (x != 0.0) {
                     p = p / x;
                     q = q / x;
                     r = r / x;
                  }
               }
               if (x == 0.0) {
                  break;
               }
               s = Math.sqrt(p * p + q * q + r * r);
               if (p < 0) {
                  s = -s;
               }
               if (s != 0) {
                  if (k != m) {
                     Jama.EigenvalueDecomposition.this.H[k][k - 1] = -s * x;
                  } else if (l != m) {
                     Jama.EigenvalueDecomposition.this.H[k][k - 1] = -Jama.EigenvalueDecomposition.this.H[k][k - 1];
                  }
                  p = p + s;
                  x = p / s;
                  y = q / s;
                  z = r / s;
                  q = q / p;
                  r = r / p;
                  for (int j = k; j < nn; j++) {
                     p = Jama.EigenvalueDecomposition.this.H[k][j] + q * Jama.EigenvalueDecomposition.this.H[k + 1][j];
                     if (notlast) {
                        p = p + r * Jama.EigenvalueDecomposition.this.H[k + 2][j];
                        Jama.EigenvalueDecomposition.this.H[k + 2][j] = Jama.EigenvalueDecomposition.this.H[k + 2][j] - p * z;
                     }
                     Jama.EigenvalueDecomposition.this.H[k][j] = Jama.EigenvalueDecomposition.this.H[k][j] - p * x;
                     Jama.EigenvalueDecomposition.this.H[k + 1][j] = Jama.EigenvalueDecomposition.this.H[k + 1][j] - p * y;
                  }
                  for (int i = 0; i <= Math.min(n, k + 3); i++) {
                     p = x * Jama.EigenvalueDecomposition.this.H[i][k] + y * Jama.EigenvalueDecomposition.this.H[i][k + 1];
                     if (notlast) {
                        p = p + z * Jama.EigenvalueDecomposition.this.H[i][k + 2];
                        Jama.EigenvalueDecomposition.this.H[i][k + 2] = Jama.EigenvalueDecomposition.this.H[i][k + 2] - p * r;
                     }
                     Jama.EigenvalueDecomposition.this.H[i][k] = Jama.EigenvalueDecomposition.this.H[i][k] - p;
                     Jama.EigenvalueDecomposition.this.H[i][k + 1] = Jama.EigenvalueDecomposition.this.H[i][k + 1] - p * q;
                  }
                  for (int i = low; i <= high; i++) {
                     p = x * Jama.EigenvalueDecomposition.this.V[i][k] + y * Jama.EigenvalueDecomposition.this.V[i][k + 1];
                     if (notlast) {
                        p = p + z * Jama.EigenvalueDecomposition.this.V[i][k + 2];
                        Jama.EigenvalueDecomposition.this.V[i][k + 2] = Jama.EigenvalueDecomposition.this.V[i][k + 2] - p * r;
                     }
                     Jama.EigenvalueDecomposition.this.V[i][k] = Jama.EigenvalueDecomposition.this.V[i][k] - p;
                     Jama.EigenvalueDecomposition.this.V[i][k + 1] = Jama.EigenvalueDecomposition.this.V[i][k + 1] - p * q;
                  }
               }
            }
         }
      }
      if (norm == 0.0) {
         return;
      }
      for (n = nn - 1; n >= 0; n--) {
         p = Jama.EigenvalueDecomposition.this.d[n];
         q = Jama.EigenvalueDecomposition.this.e[n];
         if (q == 0) {
            int l = n;
            Jama.EigenvalueDecomposition.this.H[n][n] = 1.0;
            for (int i = n - 1; i >= 0; i--) {
               w = Jama.EigenvalueDecomposition.this.H[i][i] - p;
               r = 0.0;
               for (int j = l; j <= n; j++) {
                  r = r + Jama.EigenvalueDecomposition.this.H[i][j] * Jama.EigenvalueDecomposition.this.H[j][n];
               }
               if (Jama.EigenvalueDecomposition.this.e[i] < 0.0) {
                  z = w;
                  s = r;
               } else {
                  l = i;
                  if (Jama.EigenvalueDecomposition.this.e[i] == 0.0) {
                     if (w != 0.0) {
                        Jama.EigenvalueDecomposition.this.H[i][n] = -r / w;
                     } else {
                        Jama.EigenvalueDecomposition.this.H[i][n] = -r / (eps * norm);
                     }
                  } else {
                     x = Jama.EigenvalueDecomposition.this.H[i][i + 1];
                     y = Jama.EigenvalueDecomposition.this.H[i + 1][i];
                     q = (Jama.EigenvalueDecomposition.this.d[i] - p) * (Jama.EigenvalueDecomposition.this.d[i] - p) + Jama.EigenvalueDecomposition.this.e[i] * Jama.EigenvalueDecomposition.this.e[i];
                     t = (x * s - z * r) / q;
                     Jama.EigenvalueDecomposition.this.H[i][n] = t;
                     if (Math.abs(x) > Math.abs(z)) {
                        Jama.EigenvalueDecomposition.this.H[i + 1][n] = (-r - w * t) / x;
                     } else {
                        Jama.EigenvalueDecomposition.this.H[i + 1][n] = (-s - y * t) / z;
                     }
                  }
                  t = Math.abs(Jama.EigenvalueDecomposition.this.H[i][n]);
                  if (eps * t * t > 1) {
                     for (int j = i; j <= n; j++) {
                        Jama.EigenvalueDecomposition.this.H[j][n] = Jama.EigenvalueDecomposition.this.H[j][n] / t;
                     }
                  }
               }
            }
         } else if (q < 0) {
            int l = n - 1;
            if (Math.abs(Jama.EigenvalueDecomposition.this.H[n][n - 1]) > Math.abs(Jama.EigenvalueDecomposition.this.H[n - 1][n])) {
               Jama.EigenvalueDecomposition.this.H[n - 1][n - 1] = q / Jama.EigenvalueDecomposition.this.H[n][n - 1];
               Jama.EigenvalueDecomposition.this.H[n - 1][n] = -(Jama.EigenvalueDecomposition.this.H[n][n] - p) / Jama.EigenvalueDecomposition.this.H[n][n - 1];
            } else {
               cdiv(0.0, -Jama.EigenvalueDecomposition.this.H[n - 1][n], Jama.EigenvalueDecomposition.this.H[n - 1][n - 1] - p, q);
               Jama.EigenvalueDecomposition.this.H[n - 1][n - 1] = Jama.EigenvalueDecomposition.this.cdivr;
               Jama.EigenvalueDecomposition.this.H[n - 1][n] = Jama.EigenvalueDecomposition.this.cdivi;
            }
            Jama.EigenvalueDecomposition.this.H[n][n - 1] = 0.0;
            Jama.EigenvalueDecomposition.this.H[n][n] = 1.0;
            for (int i = n - 2; i >= 0; i--) {
               double ra;
               double sa;
               double vr;
               double vi;
               ra = 0.0;
               sa = 0.0;
               for (int j = l; j <= n; j++) {
                  ra = ra + Jama.EigenvalueDecomposition.this.H[i][j] * Jama.EigenvalueDecomposition.this.H[j][n - 1];
                  sa = sa + Jama.EigenvalueDecomposition.this.H[i][j] * Jama.EigenvalueDecomposition.this.H[j][n];
               }
               w = Jama.EigenvalueDecomposition.this.H[i][i] - p;
               if (Jama.EigenvalueDecomposition.this.e[i] < 0.0) {
                  z = w;
                  r = ra;
                  s = sa;
               } else {
                  l = i;
                  if (Jama.EigenvalueDecomposition.this.e[i] == 0) {
                     cdiv(-ra, -sa, w, q);
                     Jama.EigenvalueDecomposition.this.H[i][n - 1] = Jama.EigenvalueDecomposition.this.cdivr;
                     Jama.EigenvalueDecomposition.this.H[i][n] = Jama.EigenvalueDecomposition.this.cdivi;
                  } else {
                     x = Jama.EigenvalueDecomposition.this.H[i][i + 1];
                     y = Jama.EigenvalueDecomposition.this.H[i + 1][i];
                     vr = (Jama.EigenvalueDecomposition.this.d[i] - p) * (Jama.EigenvalueDecomposition.this.d[i] - p) + Jama.EigenvalueDecomposition.this.e[i] * Jama.EigenvalueDecomposition.this.e[i] - q * q;
                     vi = (Jama.EigenvalueDecomposition.this.d[i] - p) * 2.0 * q;
                     if (vr == 0.0 & vi == 0.0) {
                        vr = eps * norm * (Math.abs(w) + Math.abs(q) + Math.abs(x) + Math.abs(y) + Math.abs(z));
                     }
                     cdiv(x * r - z * ra + q * sa, x * s - z * sa - q * ra, vr, vi);
                     Jama.EigenvalueDecomposition.this.H[i][n - 1] = Jama.EigenvalueDecomposition.this.cdivr;
                     Jama.EigenvalueDecomposition.this.H[i][n] = Jama.EigenvalueDecomposition.this.cdivi;
                     if (Math.abs(x) > Math.abs(z) + Math.abs(q)) {
                        Jama.EigenvalueDecomposition.this.H[i + 1][n - 1] = (-ra - w * Jama.EigenvalueDecomposition.this.H[i][n - 1] + q * Jama.EigenvalueDecomposition.this.H[i][n]) / x;
                        Jama.EigenvalueDecomposition.this.H[i + 1][n] = (-sa - w * Jama.EigenvalueDecomposition.this.H[i][n] - q * Jama.EigenvalueDecomposition.this.H[i][n - 1]) / x;
                     } else {
                        cdiv(-r - y * Jama.EigenvalueDecomposition.this.H[i][n - 1], -s - y * Jama.EigenvalueDecomposition.this.H[i][n], z, q);
                        Jama.EigenvalueDecomposition.this.H[i + 1][n - 1] = Jama.EigenvalueDecomposition.this.cdivr;
                        Jama.EigenvalueDecomposition.this.H[i + 1][n] = Jama.EigenvalueDecomposition.this.cdivi;
                     }
                  }
                  t = Math.max(Math.abs(Jama.EigenvalueDecomposition.this.H[i][n - 1]), Math.abs(Jama.EigenvalueDecomposition.this.H[i][n]));
                  if (eps * t * t > 1) {
                     for (int j = i; j <= n; j++) {
                        Jama.EigenvalueDecomposition.this.H[j][n - 1] = Jama.EigenvalueDecomposition.this.H[j][n - 1] / t;
                        Jama.EigenvalueDecomposition.this.H[j][n] = Jama.EigenvalueDecomposition.this.H[j][n] / t;
                     }
                  }
               }
            }
         }
      }
      for (int i = 0; i < nn; i++) {
         if (i < low | i > high) {
            for (int j = i; j < nn; j++) {
               Jama.EigenvalueDecomposition.this.V[i][j] = Jama.EigenvalueDecomposition.this.H[i][j];
            }
         }
      }
      for (int j = nn - 1; j >= low; j--) {
         for (int i = low; i <= high; i++) {
            z = 0.0;
            for (int k = low; k <= Math.min(j, high); k++) {
               z = z + Jama.EigenvalueDecomposition.this.V[i][k] * Jama.EigenvalueDecomposition.this.H[k][j];
            }
            Jama.EigenvalueDecomposition.this.V[i][j] = z;
         }
      }
   }
   private void orthes() {
      int low = 0;
      int high = Jama.EigenvalueDecomposition.this.n - 1;
      for (int m = low + 1; m <= high - 1; m++) {
         double scale = 0.0;
         for (int i = m; i <= high; i++) {
            scale = scale + Math.abs(Jama.EigenvalueDecomposition.this.H[i][m - 1]);
         }
         if (scale != 0.0) {
            double h = 0.0;
            for (int i = high; i >= m; i--) {
               Jama.EigenvalueDecomposition.this.ort[i] = Jama.EigenvalueDecomposition.this.H[i][m - 1] / scale;
               h += Jama.EigenvalueDecomposition.this.ort[i] * Jama.EigenvalueDecomposition.this.ort[i];
            }
            double g = Math.sqrt(h);
            if (Jama.EigenvalueDecomposition.this.ort[m] > 0) {
               g = -g;
            }
            h = h - Jama.EigenvalueDecomposition.this.ort[m] * g;
            Jama.EigenvalueDecomposition.this.ort[m] = Jama.EigenvalueDecomposition.this.ort[m] - g;
            for (int j = m; j < Jama.EigenvalueDecomposition.this.n; j++) {
               double f = 0.0;
               for (int i = high; i >= m; i--) {
                  f += Jama.EigenvalueDecomposition.this.ort[i] * Jama.EigenvalueDecomposition.this.H[i][j];
               }
               f = f / h;
               for (int i = m; i <= high; i++) {
                  Jama.EigenvalueDecomposition.this.H[i][j] -= f * Jama.EigenvalueDecomposition.this.ort[i];
               }
            }
            for (int i = 0; i <= high; i++) {
               double f = 0.0;
               for (int j = high; j >= m; j--) {
                  f += Jama.EigenvalueDecomposition.this.ort[j] * Jama.EigenvalueDecomposition.this.H[i][j];
               }
               f = f / h;
               for (int j = m; j <= high; j++) {
                  Jama.EigenvalueDecomposition.this.H[i][j] -= f * Jama.EigenvalueDecomposition.this.ort[j];
               }
            }
            Jama.EigenvalueDecomposition.this.ort[m] = scale * Jama.EigenvalueDecomposition.this.ort[m];
            Jama.EigenvalueDecomposition.this.H[m][m - 1] = scale * g;
         }
      }
      for (int i = 0; i < Jama.EigenvalueDecomposition.this.n; i++) {
         for (int j = 0; j < Jama.EigenvalueDecomposition.this.n; j++) {
            Jama.EigenvalueDecomposition.this.V[i][j] = i == j ? 1.0 : 0.0;
         }
      }
      for (int m = high - 1; m >= low + 1; m--) {
         if (Jama.EigenvalueDecomposition.this.H[m][m - 1] != 0.0) {
            for (int i = m + 1; i <= high; i++) {
               Jama.EigenvalueDecomposition.this.ort[i] = Jama.EigenvalueDecomposition.this.H[i][m - 1];
            }
            for (int j = m; j <= high; j++) {
               double g = 0.0;
               for (int i = m; i <= high; i++) {
                  g += Jama.EigenvalueDecomposition.this.ort[i] * Jama.EigenvalueDecomposition.this.V[i][j];
               }
               g = g / Jama.EigenvalueDecomposition.this.ort[m] / Jama.EigenvalueDecomposition.this.H[m][m - 1];
               for (int i = m; i <= high; i++) {
                  Jama.EigenvalueDecomposition.this.V[i][j] += g * Jama.EigenvalueDecomposition.this.ort[i];
               }
            }
         }
      }
   }
   private void tql2() {
      for (int i = 1; i < Jama.EigenvalueDecomposition.this.n; i++) {
         Jama.EigenvalueDecomposition.this.e[i - 1] = Jama.EigenvalueDecomposition.this.e[i];
      }
      Jama.EigenvalueDecomposition.this.e[Jama.EigenvalueDecomposition.this.n - 1] = 0.0;
      double f = 0.0;
      double tst1 = 0.0;
      double eps = Math.pow(2.0, -52.0);
      for (int l = 0; l < Jama.EigenvalueDecomposition.this.n; l++) {
         tst1 = Math.max(tst1, Math.abs(Jama.EigenvalueDecomposition.this.d[l]) + Math.abs(Jama.EigenvalueDecomposition.this.e[l]));
         int m = l;
         while (m < Jama.EigenvalueDecomposition.this.n) {
            if (Math.abs(Jama.EigenvalueDecomposition.this.e[m]) <= eps * tst1) {
               break;
            }
            m++;
         }
         if (m > l) {
            int iter = 0;
            do {
               iter = iter + 1;
               double g = Jama.EigenvalueDecomposition.this.d[l];
               double p = (Jama.EigenvalueDecomposition.this.d[l + 1] - g) / (2.0 * Jama.EigenvalueDecomposition.this.e[l]);
               double r = Maths.hypot(p, 1.0);
               if (p < 0) {
                  r = -r;
               }
               Jama.EigenvalueDecomposition.this.d[l] = Jama.EigenvalueDecomposition.this.e[l] / (p + r);
               Jama.EigenvalueDecomposition.this.d[l + 1] = Jama.EigenvalueDecomposition.this.e[l] * (p + r);
               double dl1 = Jama.EigenvalueDecomposition.this.d[l + 1];
               double h = g - Jama.EigenvalueDecomposition.this.d[l];
               for (int i = l + 2; i < Jama.EigenvalueDecomposition.this.n; i++) {
                  Jama.EigenvalueDecomposition.this.d[i] -= h;
               }
               f = f + h;
               p = Jama.EigenvalueDecomposition.this.d[m];
               double c = 1.0;
               double c2 = c;
               double c3 = c;
               double el1 = Jama.EigenvalueDecomposition.this.e[l + 1];
               double s = 0.0;
               double s2 = 0.0;
               for (int i = m - 1; i >= l; i--) {
                  c3 = c2;
                  c2 = c;
                  s2 = s;
                  g = c * Jama.EigenvalueDecomposition.this.e[i];
                  h = c * p;
                  r = Maths.hypot(p, Jama.EigenvalueDecomposition.this.e[i]);
                  Jama.EigenvalueDecomposition.this.e[i + 1] = s * r;
                  s = Jama.EigenvalueDecomposition.this.e[i] / r;
                  c = p / r;
                  p = c * Jama.EigenvalueDecomposition.this.d[i] - s * g;
                  Jama.EigenvalueDecomposition.this.d[i + 1] = h + s * (c * g + s * Jama.EigenvalueDecomposition.this.d[i]);
                  for (int k = 0; k < Jama.EigenvalueDecomposition.this.n; k++) {
                     h = Jama.EigenvalueDecomposition.this.V[k][i + 1];
                     Jama.EigenvalueDecomposition.this.V[k][i + 1] = s * Jama.EigenvalueDecomposition.this.V[k][i] + c * h;
                     Jama.EigenvalueDecomposition.this.V[k][i] = c * Jama.EigenvalueDecomposition.this.V[k][i] - s * h;
                  }
               }
               p = -s * s2 * c3 * el1 * Jama.EigenvalueDecomposition.this.e[l] / dl1;
               Jama.EigenvalueDecomposition.this.e[l] = s * p;
               Jama.EigenvalueDecomposition.this.d[l] = c * p;
            }             while (Math.abs(Jama.EigenvalueDecomposition.this.e[l]) > eps * tst1);
         }
         Jama.EigenvalueDecomposition.this.d[l] = Jama.EigenvalueDecomposition.this.d[l] + f;
         Jama.EigenvalueDecomposition.this.e[l] = 0.0;
      }
      for (int i = 0; i < Jama.EigenvalueDecomposition.this.n - 1; i++) {
         int k = i;
         double p = Jama.EigenvalueDecomposition.this.d[i];
         for (int j = i + 1; j < Jama.EigenvalueDecomposition.this.n; j++) {
            if (Jama.EigenvalueDecomposition.this.d[j] < p) {
               k = j;
               p = Jama.EigenvalueDecomposition.this.d[j];
            }
         }
         if (k != i) {
            Jama.EigenvalueDecomposition.this.d[k] = Jama.EigenvalueDecomposition.this.d[i];
            Jama.EigenvalueDecomposition.this.d[i] = p;
            for (int j = 0; j < Jama.EigenvalueDecomposition.this.n; j++) {
               p = Jama.EigenvalueDecomposition.this.V[j][i];
               Jama.EigenvalueDecomposition.this.V[j][i] = Jama.EigenvalueDecomposition.this.V[j][k];
               Jama.EigenvalueDecomposition.this.V[j][k] = p;
            }
         }
      }
   }
   private void tred2() {
      for (int j = 0; j < Jama.EigenvalueDecomposition.this.n; j++) {
         Jama.EigenvalueDecomposition.this.d[j] = Jama.EigenvalueDecomposition.this.V[Jama.EigenvalueDecomposition.this.n - 1][j];
      }
      for (int i = Jama.EigenvalueDecomposition.this.n - 1; i > 0; i--) {
         double scale = 0.0;
         double h = 0.0;
         for (int k = 0; k < i; k++) {
            scale = scale + Math.abs(Jama.EigenvalueDecomposition.this.d[k]);
         }
         if (scale == 0.0) {
            Jama.EigenvalueDecomposition.this.e[i] = Jama.EigenvalueDecomposition.this.d[i - 1];
            for (int j = 0; j < i; j++) {
               Jama.EigenvalueDecomposition.this.d[j] = Jama.EigenvalueDecomposition.this.V[i - 1][j];
               Jama.EigenvalueDecomposition.this.V[i][j] = 0.0;
               Jama.EigenvalueDecomposition.this.V[j][i] = 0.0;
            }
         } else {
            for (int k = 0; k < i; k++) {
               Jama.EigenvalueDecomposition.this.d[k] /= scale;
               h += Jama.EigenvalueDecomposition.this.d[k] * Jama.EigenvalueDecomposition.this.d[k];
            }
            double f = Jama.EigenvalueDecomposition.this.d[i - 1];
            double g = Math.sqrt(h);
            if (f > 0) {
               g = -g;
            }
            Jama.EigenvalueDecomposition.this.e[i] = scale * g;
            h = h - f * g;
            Jama.EigenvalueDecomposition.this.d[i - 1] = f - g;
            for (int j = 0; j < i; j++) {
               Jama.EigenvalueDecomposition.this.e[j] = 0.0;
            }
            for (int j = 0; j < i; j++) {
               f = Jama.EigenvalueDecomposition.this.d[j];
               Jama.EigenvalueDecomposition.this.V[j][i] = f;
               g = Jama.EigenvalueDecomposition.this.e[j] + Jama.EigenvalueDecomposition.this.V[j][j] * f;
               for (int k = j + 1; k <= i - 1; k++) {
                  g += Jama.EigenvalueDecomposition.this.V[k][j] * Jama.EigenvalueDecomposition.this.d[k];
                  Jama.EigenvalueDecomposition.this.e[k] += Jama.EigenvalueDecomposition.this.V[k][j] * f;
               }
               Jama.EigenvalueDecomposition.this.e[j] = g;
            }
            f = 0.0;
            for (int j = 0; j < i; j++) {
               Jama.EigenvalueDecomposition.this.e[j] /= h;
               f += Jama.EigenvalueDecomposition.this.e[j] * Jama.EigenvalueDecomposition.this.d[j];
            }
            double hh = f / (h + h);
            for (int j = 0; j < i; j++) {
               Jama.EigenvalueDecomposition.this.e[j] -= hh * Jama.EigenvalueDecomposition.this.d[j];
            }
            for (int j = 0; j < i; j++) {
               f = Jama.EigenvalueDecomposition.this.d[j];
               g = Jama.EigenvalueDecomposition.this.e[j];
               for (int k = j; k <= i - 1; k++) {
                  Jama.EigenvalueDecomposition.this.V[k][j] -= f * Jama.EigenvalueDecomposition.this.e[k] + g * Jama.EigenvalueDecomposition.this.d[k];
               }
               Jama.EigenvalueDecomposition.this.d[j] = Jama.EigenvalueDecomposition.this.V[i - 1][j];
               Jama.EigenvalueDecomposition.this.V[i][j] = 0.0;
            }
         }
         Jama.EigenvalueDecomposition.this.d[i] = h;
      }
      for (int i = 0; i < Jama.EigenvalueDecomposition.this.n - 1; i++) {
         Jama.EigenvalueDecomposition.this.V[Jama.EigenvalueDecomposition.this.n - 1][i] = Jama.EigenvalueDecomposition.this.V[i][i];
         Jama.EigenvalueDecomposition.this.V[i][i] = 1.0;
         double h = Jama.EigenvalueDecomposition.this.d[i + 1];
         if (h != 0.0) {
            for (int k = 0; k <= i; k++) {
               Jama.EigenvalueDecomposition.this.d[k] = Jama.EigenvalueDecomposition.this.V[k][i + 1] / h;
            }
            for (int j = 0; j <= i; j++) {
               double g = 0.0;
               for (int k = 0; k <= i; k++) {
                  g += Jama.EigenvalueDecomposition.this.V[k][i + 1] * Jama.EigenvalueDecomposition.this.V[k][j];
               }
               for (int k = 0; k <= i; k++) {
                  Jama.EigenvalueDecomposition.this.V[k][j] -= g * Jama.EigenvalueDecomposition.this.d[k];
               }
            }
         }
         for (int k = 0; k <= i; k++) {
            Jama.EigenvalueDecomposition.this.V[k][i + 1] = 0.0;
         }
      }
      for (int j = 0; j < Jama.EigenvalueDecomposition.this.n; j++) {
         Jama.EigenvalueDecomposition.this.d[j] = Jama.EigenvalueDecomposition.this.V[Jama.EigenvalueDecomposition.this.n - 1][j];
         Jama.EigenvalueDecomposition.this.V[Jama.EigenvalueDecomposition.this.n - 1][j] = 0.0;
      }
      Jama.EigenvalueDecomposition.this.V[Jama.EigenvalueDecomposition.this.n - 1][Jama.EigenvalueDecomposition.this.n - 1] = 1.0;
      Jama.EigenvalueDecomposition.this.e[0] = 0.0;
   }
}
